/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');
var Error = require('./Error');
var LoyaltyEvent = require('./LoyaltyEvent');




/**
 * The AdjustLoyaltyPointsResponse model module.
 * Note: This model is in beta.
 * @module model/AdjustLoyaltyPointsResponse
 */

/**
 * Constructs a new <code>AdjustLoyaltyPointsResponse</code>.
 * A response that includes the loyalty event that  resulted from the successful API call.
 * @alias module:model/AdjustLoyaltyPointsResponse
 * @class
 */
var exports = function() {
  var _this = this;



};

/**
 * Constructs a <code>AdjustLoyaltyPointsResponse</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/AdjustLoyaltyPointsResponse} obj Optional instance to populate.
 * @return {module:model/AdjustLoyaltyPointsResponse} The populated <code>AdjustLoyaltyPointsResponse</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('errors')) {
      obj['errors'] = ApiClient.convertToType(data['errors'], [Error]);
    }
      if (data.hasOwnProperty('event')) {
      obj['event'] = LoyaltyEvent.constructFromObject(data['event']);
    }
    }
  return obj;
}

/**
 * Any errors that occurred during the request.
 * @member {Array.<module:model/Error>} errors
 */
exports.prototype['errors'] = undefined;
/**
 * The resulting event data for adjusting points.
 * @member {module:model/LoyaltyEvent} event
 */
exports.prototype['event'] = undefined;



module.exports = exports;



