/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');
var CreateTeamMemberRequest = require('./CreateTeamMemberRequest');




/**
 * The BulkCreateTeamMembersRequest model module.
 * @module model/BulkCreateTeamMembersRequest
 */

/**
 * Constructs a new <code>BulkCreateTeamMembersRequest</code>.
 * Represents a bulk create request for &#x60;TeamMember&#x60; objects.
 * @alias module:model/BulkCreateTeamMembersRequest
 * @class
 * @param teamMembers {Object.<String, module:model/CreateTeamMemberRequest>} The data which will be used to create the `TeamMember` objects. Each key is the `idempotency_key` that maps to the `CreateTeamMemberRequest`.
 */
var exports = function(teamMembers) {
  var _this = this;

  _this['team_members'] = teamMembers;
};

/**
 * Constructs a <code>BulkCreateTeamMembersRequest</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/BulkCreateTeamMembersRequest} obj Optional instance to populate.
 * @return {module:model/BulkCreateTeamMembersRequest} The populated <code>BulkCreateTeamMembersRequest</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('team_members')) {
      obj['team_members'] = ApiClient.convertToType(data['team_members'], {'String': CreateTeamMemberRequest});
    }
    }
  return obj;
}

/**
 * The data which will be used to create the `TeamMember` objects. Each key is the `idempotency_key` that maps to the `CreateTeamMemberRequest`.
 * @member {Object.<String, module:model/CreateTeamMemberRequest>} team_members
 */
exports.prototype['team_members'] = undefined;



module.exports = exports;



