/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');
var Error = require('./Error');
var UpdateTeamMemberResponse = require('./UpdateTeamMemberResponse');




/**
 * The BulkUpdateTeamMembersResponse model module.
 * @module model/BulkUpdateTeamMembersResponse
 */

/**
 * Constructs a new <code>BulkUpdateTeamMembersResponse</code>.
 * Represents a response from a bulk update request, containing the updated &#x60;TeamMember&#x60; objects or error messages.
 * @alias module:model/BulkUpdateTeamMembersResponse
 * @class
 */
var exports = function() {
  var _this = this;



};

/**
 * Constructs a <code>BulkUpdateTeamMembersResponse</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/BulkUpdateTeamMembersResponse} obj Optional instance to populate.
 * @return {module:model/BulkUpdateTeamMembersResponse} The populated <code>BulkUpdateTeamMembersResponse</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('team_members')) {
      obj['team_members'] = ApiClient.convertToType(data['team_members'], {'String': UpdateTeamMemberResponse});
    }
      if (data.hasOwnProperty('errors')) {
      obj['errors'] = ApiClient.convertToType(data['errors'], [Error]);
    }
    }
  return obj;
}

/**
 * The successfully updated `TeamMember` objects. Each key is the `team_member_id` that maps to the `UpdateTeamMemberRequest`.
 * @member {Object.<String, module:model/UpdateTeamMemberResponse>} team_members
 */
exports.prototype['team_members'] = undefined;
/**
 * The errors that occurred during the request.
 * @member {Array.<module:model/Error>} errors
 */
exports.prototype['errors'] = undefined;



module.exports = exports;



