/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');
var CatalogModifierOverride = require('./CatalogModifierOverride');




/**
 * The CatalogItemModifierListInfo model module.
 * @module model/CatalogItemModifierListInfo
 */

/**
 * Constructs a new <code>CatalogItemModifierListInfo</code>.
 * Options to control the properties of a &#x60;CatalogModifierList&#x60; applied to a &#x60;CatalogItem&#x60; instance.
 * @alias module:model/CatalogItemModifierListInfo
 * @class
 * @param modifierListId {String} The ID of the `CatalogModifierList` controlled by this `CatalogModifierListInfo`.
 */
var exports = function(modifierListId) {
  var _this = this;

  _this['modifier_list_id'] = modifierListId;




};

/**
 * Constructs a <code>CatalogItemModifierListInfo</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/CatalogItemModifierListInfo} obj Optional instance to populate.
 * @return {module:model/CatalogItemModifierListInfo} The populated <code>CatalogItemModifierListInfo</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('modifier_list_id')) {
      obj['modifier_list_id'] = ApiClient.convertToType(data['modifier_list_id'], 'String');
    }
      if (data.hasOwnProperty('modifier_overrides')) {
      obj['modifier_overrides'] = ApiClient.convertToType(data['modifier_overrides'], [CatalogModifierOverride]);
    }
      if (data.hasOwnProperty('min_selected_modifiers')) {
      obj['min_selected_modifiers'] = ApiClient.convertToType(data['min_selected_modifiers'], 'Number');
    }
      if (data.hasOwnProperty('max_selected_modifiers')) {
      obj['max_selected_modifiers'] = ApiClient.convertToType(data['max_selected_modifiers'], 'Number');
    }
      if (data.hasOwnProperty('enabled')) {
      obj['enabled'] = ApiClient.convertToType(data['enabled'], 'Boolean');
    }
    }
  return obj;
}

/**
 * The ID of the `CatalogModifierList` controlled by this `CatalogModifierListInfo`.
 * @member {String} modifier_list_id
 */
exports.prototype['modifier_list_id'] = undefined;
/**
 * A set of `CatalogModifierOverride` objects that override whether a given `CatalogModifier` is enabled by default.
 * @member {Array.<module:model/CatalogModifierOverride>} modifier_overrides
 */
exports.prototype['modifier_overrides'] = undefined;
/**
 * If 0 or larger, the smallest number of `CatalogModifier`s that must be selected from this `CatalogModifierList`.
 * @member {Number} min_selected_modifiers
 */
exports.prototype['min_selected_modifiers'] = undefined;
/**
 * If 0 or larger, the largest number of `CatalogModifier`s that can be selected from this `CatalogModifierList`.
 * @member {Number} max_selected_modifiers
 */
exports.prototype['max_selected_modifiers'] = undefined;
/**
 * If `true`, enable this `CatalogModifierList`. The default value is `true`.
 * @member {Boolean} enabled
 */
exports.prototype['enabled'] = undefined;



module.exports = exports;



