/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');




/**
 * The Employee model module.
 * @module model/Employee
 */

/**
 * Constructs a new <code>Employee</code>.
 * An employee object that is used by the external API.
 * @alias module:model/Employee
 * @class
 */
var exports = function() {
  var _this = this;











};

/**
 * Constructs a <code>Employee</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/Employee} obj Optional instance to populate.
 * @return {module:model/Employee} The populated <code>Employee</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
      obj['id'] = ApiClient.convertToType(data['id'], 'String');
    }
      if (data.hasOwnProperty('first_name')) {
      obj['first_name'] = ApiClient.convertToType(data['first_name'], 'String');
    }
      if (data.hasOwnProperty('last_name')) {
      obj['last_name'] = ApiClient.convertToType(data['last_name'], 'String');
    }
      if (data.hasOwnProperty('email')) {
      obj['email'] = ApiClient.convertToType(data['email'], 'String');
    }
      if (data.hasOwnProperty('phone_number')) {
      obj['phone_number'] = ApiClient.convertToType(data['phone_number'], 'String');
    }
      if (data.hasOwnProperty('location_ids')) {
      obj['location_ids'] = ApiClient.convertToType(data['location_ids'], ['String']);
    }
      if (data.hasOwnProperty('status')) {
      obj['status'] = ApiClient.convertToType(data['status'], 'String');
    }
      if (data.hasOwnProperty('is_owner')) {
      obj['is_owner'] = ApiClient.convertToType(data['is_owner'], 'Boolean');
    }
      if (data.hasOwnProperty('created_at')) {
      obj['created_at'] = ApiClient.convertToType(data['created_at'], 'String');
    }
      if (data.hasOwnProperty('updated_at')) {
      obj['updated_at'] = ApiClient.convertToType(data['updated_at'], 'String');
    }
    }
  return obj;
}

/**
 * UUID for this object.
 * @member {String} id
 */
exports.prototype['id'] = undefined;
/**
 * The employee's first name.
 * @member {String} first_name
 */
exports.prototype['first_name'] = undefined;
/**
 * The employee's last name.
 * @member {String} last_name
 */
exports.prototype['last_name'] = undefined;
/**
 * The employee's email address
 * @member {String} email
 */
exports.prototype['email'] = undefined;
/**
 * The employee's phone number in E.164 format, i.e. \"+12125554250\"
 * @member {String} phone_number
 */
exports.prototype['phone_number'] = undefined;
/**
 * A list of location IDs where this employee has access to.
 * @member {Array.<String>} location_ids
 */
exports.prototype['location_ids'] = undefined;
/**
 * Specifies the status of the employees being fetched. See [EmployeeStatus](#type-employeestatus) for possible values
 * @member {String} status
 */
exports.prototype['status'] = undefined;
/**
 * Whether this employee is the owner of the merchant. Each merchant has one owner employee, and that employee has full authority over the account.
 * @member {Boolean} is_owner
 */
exports.prototype['is_owner'] = undefined;
/**
 * A read-only timestamp in RFC 3339 format.
 * @member {String} created_at
 */
exports.prototype['created_at'] = undefined;
/**
 * A read-only timestamp in RFC 3339 format.
 * @member {String} updated_at
 */
exports.prototype['updated_at'] = undefined;



module.exports = exports;



