/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');
var Error = require('./Error');
var SubscriptionEvent = require('./SubscriptionEvent');




/**
 * The ListSubscriptionEventsResponse model module.
 * Note: This model is in beta.
 * @module model/ListSubscriptionEventsResponse
 */

/**
 * Constructs a new <code>ListSubscriptionEventsResponse</code>.
 * Defines the fields that are included in the response from the [ListSubscriptionEvents](#endpoint-subscriptions-listsubscriptionevents) endpoint.
 * @alias module:model/ListSubscriptionEventsResponse
 * @class
 */
var exports = function() {
  var _this = this;




};

/**
 * Constructs a <code>ListSubscriptionEventsResponse</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/ListSubscriptionEventsResponse} obj Optional instance to populate.
 * @return {module:model/ListSubscriptionEventsResponse} The populated <code>ListSubscriptionEventsResponse</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('errors')) {
      obj['errors'] = ApiClient.convertToType(data['errors'], [Error]);
    }
      if (data.hasOwnProperty('subscription_events')) {
      obj['subscription_events'] = ApiClient.convertToType(data['subscription_events'], [SubscriptionEvent]);
    }
      if (data.hasOwnProperty('cursor')) {
      obj['cursor'] = ApiClient.convertToType(data['cursor'], 'String');
    }
    }
  return obj;
}

/**
 * Information about errors encountered during the request.
 * @member {Array.<module:model/Error>} errors
 */
exports.prototype['errors'] = undefined;
/**
 * The `SubscriptionEvents` retrieved.
 * @member {Array.<module:model/SubscriptionEvent>} subscription_events
 */
exports.prototype['subscription_events'] = undefined;
/**
 * When a response is truncated, it includes a cursor that you can  use in a subsequent request to fetch the next set of events.  If empty, this is the final response.  For more information, see [Pagination](https://developer.squareup.com/docs/docs/working-with-apis/pagination).
 * @member {String} cursor
 */
exports.prototype['cursor'] = undefined;



module.exports = exports;



