/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');




/**
 * The LoyaltyEventRedeemReward model module.
 * Note: This model is in beta.
 * @module model/LoyaltyEventRedeemReward
 */

/**
 * Constructs a new <code>LoyaltyEventRedeemReward</code>.
 * Provides metadata when the event &#x60;type&#x60; is &#x60;REDEEM_REWARD&#x60;.
 * @alias module:model/LoyaltyEventRedeemReward
 * @class
 * @param loyaltyProgramId {String} The ID of the `loyalty program`.
 */
var exports = function(loyaltyProgramId) {
  var _this = this;

  _this['loyalty_program_id'] = loyaltyProgramId;


};

/**
 * Constructs a <code>LoyaltyEventRedeemReward</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/LoyaltyEventRedeemReward} obj Optional instance to populate.
 * @return {module:model/LoyaltyEventRedeemReward} The populated <code>LoyaltyEventRedeemReward</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('loyalty_program_id')) {
      obj['loyalty_program_id'] = ApiClient.convertToType(data['loyalty_program_id'], 'String');
    }
      if (data.hasOwnProperty('reward_id')) {
      obj['reward_id'] = ApiClient.convertToType(data['reward_id'], 'String');
    }
      if (data.hasOwnProperty('order_id')) {
      obj['order_id'] = ApiClient.convertToType(data['order_id'], 'String');
    }
    }
  return obj;
}

/**
 * The ID of the `loyalty program`.
 * @member {String} loyalty_program_id
 */
exports.prototype['loyalty_program_id'] = undefined;
/**
 * The ID of the redeemed `loyalty reward`. This field is returned only if the event source is `LOYALTY_API`.
 * @member {String} reward_id
 */
exports.prototype['reward_id'] = undefined;
/**
 * The ID of the `order` that redeemed the reward. This field is returned only if the Orders API is used to process orders.
 * @member {String} order_id
 */
exports.prototype['order_id'] = undefined;



module.exports = exports;



