/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');




/**
 * The OrderFulfillmentUpdatedUpdate model module.
 * Note: This model is in beta.
 * @module model/OrderFulfillmentUpdatedUpdate
 */

/**
 * Constructs a new <code>OrderFulfillmentUpdatedUpdate</code>.
 * Information about fulfillment updates.
 * @alias module:model/OrderFulfillmentUpdatedUpdate
 * @class
 */
var exports = function() {
  var _this = this;




};

/**
 * Constructs a <code>OrderFulfillmentUpdatedUpdate</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/OrderFulfillmentUpdatedUpdate} obj Optional instance to populate.
 * @return {module:model/OrderFulfillmentUpdatedUpdate} The populated <code>OrderFulfillmentUpdatedUpdate</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('fulfillment_uid')) {
      obj['fulfillment_uid'] = ApiClient.convertToType(data['fulfillment_uid'], 'String');
    }
      if (data.hasOwnProperty('old_state')) {
      obj['old_state'] = ApiClient.convertToType(data['old_state'], 'String');
    }
      if (data.hasOwnProperty('new_state')) {
      obj['new_state'] = ApiClient.convertToType(data['new_state'], 'String');
    }
    }
  return obj;
}

/**
 * Unique ID that identifies the fulfillment only within this order.
 * @member {String} fulfillment_uid
 */
exports.prototype['fulfillment_uid'] = undefined;
/**
 * The state of the fulfillment before the change. Will not be populated if the fulfillment is created with this new Order version. See [OrderFulfillmentState](#type-orderfulfillmentstate) for possible values
 * @member {String} old_state
 */
exports.prototype['old_state'] = undefined;
/**
 * The state of the fulfillment after the change. May be equal to old_state if a non-state field was changed on the fulfillment (e.g. tracking number). See [OrderFulfillmentState](#type-orderfulfillmentstate) for possible values
 * @member {String} new_state
 */
exports.prototype['new_state'] = undefined;



module.exports = exports;



