/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');




/**
 * The RedeemLoyaltyRewardRequest model module.
 * Note: This model is in beta.
 * @module model/RedeemLoyaltyRewardRequest
 */

/**
 * Constructs a new <code>RedeemLoyaltyRewardRequest</code>.
 * A request to redeem a loyalty reward.
 * @alias module:model/RedeemLoyaltyRewardRequest
 * @class
 * @param idempotencyKey {String} A unique string that identifies this `RedeemLoyaltyReward` request.  Keys can be any valid string, but must be unique for every request.
 * @param locationId {String} The ID of the `location` where the reward is redeemed.
 */
var exports = function(idempotencyKey, locationId) {
  var _this = this;

  _this['idempotency_key'] = idempotencyKey;
  _this['location_id'] = locationId;
};

/**
 * Constructs a <code>RedeemLoyaltyRewardRequest</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/RedeemLoyaltyRewardRequest} obj Optional instance to populate.
 * @return {module:model/RedeemLoyaltyRewardRequest} The populated <code>RedeemLoyaltyRewardRequest</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('idempotency_key')) {
      obj['idempotency_key'] = ApiClient.convertToType(data['idempotency_key'], 'String');
    }
      if (data.hasOwnProperty('location_id')) {
      obj['location_id'] = ApiClient.convertToType(data['location_id'], 'String');
    }
    }
  return obj;
}

/**
 * A unique string that identifies this `RedeemLoyaltyReward` request.  Keys can be any valid string, but must be unique for every request.
 * @member {String} idempotency_key
 */
exports.prototype['idempotency_key'] = undefined;
/**
 * The ID of the `location` where the reward is redeemed.
 * @member {String} location_id
 */
exports.prototype['location_id'] = undefined;



module.exports = exports;



