/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');
var InvoiceQuery = require('./InvoiceQuery');




/**
 * The SearchInvoicesRequest model module.
 * Note: This model is in beta.
 * @module model/SearchInvoicesRequest
 */

/**
 * Constructs a new <code>SearchInvoicesRequest</code>.
 * Describes a &#x60;SearchInvoices&#x60; request.
 * @alias module:model/SearchInvoicesRequest
 * @class
 * @param query {module:model/InvoiceQuery} Describes the query criteria for searching invoices.
 */
var exports = function(query) {
  var _this = this;

  _this['query'] = query;


};

/**
 * Constructs a <code>SearchInvoicesRequest</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/SearchInvoicesRequest} obj Optional instance to populate.
 * @return {module:model/SearchInvoicesRequest} The populated <code>SearchInvoicesRequest</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('query')) {
      obj['query'] = InvoiceQuery.constructFromObject(data['query']);
    }
      if (data.hasOwnProperty('limit')) {
      obj['limit'] = ApiClient.convertToType(data['limit'], 'Number');
    }
      if (data.hasOwnProperty('cursor')) {
      obj['cursor'] = ApiClient.convertToType(data['cursor'], 'String');
    }
    }
  return obj;
}

/**
 * Describes the query criteria for searching invoices.
 * @member {module:model/InvoiceQuery} query
 */
exports.prototype['query'] = undefined;
/**
 * The maximum number of invoices to return (200 is the maximum `limit`).  If not provided, the server  uses a default limit of 100 invoices.
 * @member {Number} limit
 */
exports.prototype['limit'] = undefined;
/**
 * A pagination cursor returned by a previous call to this endpoint.  Provide this cursor to retrieve the next set of results for your original query.  For more information, see [Pagination](https://developer.squareup.com/docs/docs/working-with-apis/pagination).
 * @member {String} cursor
 */
exports.prototype['cursor'] = undefined;



module.exports = exports;



