/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');
var Error = require('./Error');
var LoyaltyEvent = require('./LoyaltyEvent');




/**
 * The SearchLoyaltyEventsResponse model module.
 * Note: This model is in beta.
 * @module model/SearchLoyaltyEventsResponse
 */

/**
 * Constructs a new <code>SearchLoyaltyEventsResponse</code>.
 * A response that contains loyalty events that satisfy the search  criteria, in order by the &#x60;created_at&#x60; date.
 * @alias module:model/SearchLoyaltyEventsResponse
 * @class
 */
var exports = function() {
  var _this = this;




};

/**
 * Constructs a <code>SearchLoyaltyEventsResponse</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/SearchLoyaltyEventsResponse} obj Optional instance to populate.
 * @return {module:model/SearchLoyaltyEventsResponse} The populated <code>SearchLoyaltyEventsResponse</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('errors')) {
      obj['errors'] = ApiClient.convertToType(data['errors'], [Error]);
    }
      if (data.hasOwnProperty('events')) {
      obj['events'] = ApiClient.convertToType(data['events'], [LoyaltyEvent]);
    }
      if (data.hasOwnProperty('cursor')) {
      obj['cursor'] = ApiClient.convertToType(data['cursor'], 'String');
    }
    }
  return obj;
}

/**
 * Any errors that occurred during the request.
 * @member {Array.<module:model/Error>} errors
 */
exports.prototype['errors'] = undefined;
/**
 * The loyalty events that satisfy the search criteria.
 * @member {Array.<module:model/LoyaltyEvent>} events
 */
exports.prototype['events'] = undefined;
/**
 * The pagination cursor to be used in a subsequent  request. If empty, this is the final response.  For more information,  see [Pagination](https://developer.squareup.com/docs/docs/basics/api101/pagination).
 * @member {String} cursor
 */
exports.prototype['cursor'] = undefined;



module.exports = exports;



