/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');
var TeamMemberAssignedLocations = require('./TeamMemberAssignedLocations');




/**
 * The TeamMember model module.
 * @module model/TeamMember
 */

/**
 * Constructs a new <code>TeamMember</code>.
 * A record representing an individual team member for a business.
 * @alias module:model/TeamMember
 * @class
 */
var exports = function() {
  var _this = this;












};

/**
 * Constructs a <code>TeamMember</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/TeamMember} obj Optional instance to populate.
 * @return {module:model/TeamMember} The populated <code>TeamMember</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
      obj['id'] = ApiClient.convertToType(data['id'], 'String');
    }
      if (data.hasOwnProperty('reference_id')) {
      obj['reference_id'] = ApiClient.convertToType(data['reference_id'], 'String');
    }
      if (data.hasOwnProperty('is_owner')) {
      obj['is_owner'] = ApiClient.convertToType(data['is_owner'], 'Boolean');
    }
      if (data.hasOwnProperty('status')) {
      obj['status'] = ApiClient.convertToType(data['status'], 'String');
    }
      if (data.hasOwnProperty('given_name')) {
      obj['given_name'] = ApiClient.convertToType(data['given_name'], 'String');
    }
      if (data.hasOwnProperty('family_name')) {
      obj['family_name'] = ApiClient.convertToType(data['family_name'], 'String');
    }
      if (data.hasOwnProperty('email_address')) {
      obj['email_address'] = ApiClient.convertToType(data['email_address'], 'String');
    }
      if (data.hasOwnProperty('phone_number')) {
      obj['phone_number'] = ApiClient.convertToType(data['phone_number'], 'String');
    }
      if (data.hasOwnProperty('created_at')) {
      obj['created_at'] = ApiClient.convertToType(data['created_at'], 'String');
    }
      if (data.hasOwnProperty('updated_at')) {
      obj['updated_at'] = ApiClient.convertToType(data['updated_at'], 'String');
    }
      if (data.hasOwnProperty('assigned_locations')) {
      obj['assigned_locations'] = TeamMemberAssignedLocations.constructFromObject(data['assigned_locations']);
    }
    }
  return obj;
}

/**
 * The unique ID for the team member.
 * @member {String} id
 */
exports.prototype['id'] = undefined;
/**
 * A second ID used to associate the team member with an entity in another system.
 * @member {String} reference_id
 */
exports.prototype['reference_id'] = undefined;
/**
 * Whether the team member is the owner of the Square account.
 * @member {Boolean} is_owner
 */
exports.prototype['is_owner'] = undefined;
/**
 * Describes the status of the team member. See [TeamMemberStatus](#type-teammemberstatus) for possible values
 * @member {String} status
 */
exports.prototype['status'] = undefined;
/**
 * The given (i.e., first) name associated with the team member.
 * @member {String} given_name
 */
exports.prototype['given_name'] = undefined;
/**
 * The family (i.e., last) name associated with the team member.
 * @member {String} family_name
 */
exports.prototype['family_name'] = undefined;
/**
 * The email address associated with the team member.
 * @member {String} email_address
 */
exports.prototype['email_address'] = undefined;
/**
 * The team member's phone number in E.164 format. Examples: +14155552671 - the country code is 1 for US +551155256325 - the country code is 55 for BR
 * @member {String} phone_number
 */
exports.prototype['phone_number'] = undefined;
/**
 * The timestamp in RFC 3339 format describing when the team member was created. Ex: \"2018-10-04T04:00:00-07:00\" or \"2019-02-05T12:00:00Z\"
 * @member {String} created_at
 */
exports.prototype['created_at'] = undefined;
/**
 * The timestamp in RFC 3339 format describing when the team member was last updated. Ex: \"2018-10-04T04:00:00-07:00\" or \"2019-02-05T12:00:00Z\"
 * @member {String} updated_at
 */
exports.prototype['updated_at'] = undefined;
/**
 * Describes the team member's assigned locations.
 * @member {module:model/TeamMemberAssignedLocations} assigned_locations
 */
exports.prototype['assigned_locations'] = undefined;



module.exports = exports;



